﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;

	public class box3d extends MovieClip{
		const SPEED:Number = 20;
		const ROTATION:Number = Math.PI/16;
		
		var cx:Number = 0;
		var cy:Number = 0;
		var cz:Number = 0;
		var vw:Number = stage.stageWidth/2;
		var vh:Number = stage.stageHeight/2;
		
		var bx:Array = [-50, 50, 50, -50, -50, 50, 50, -50];
		var by:Array = [-50, -50, 50, 50, -50, -50, 50, 50];
		var bz:Array = [200, 200, 200, 200, 300, 300, 300, 300];
		
		var key:Number = 0;
		var a:Number = 0;
		
		public function box3d() {
			addEventListener(Event.ENTER_FRAME,render);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,eventKeyDown);
			stage.addEventListener(KeyboardEvent.KEY_UP,eventKeyUp);
        }

		private function render(event:Event):void {
			
			switch(key&0x0000ff) {
				case 0x00000f:
					cz += Math.cos(-a)*SPEED;
					cx += Math.sin(-a)*SPEED;
					break;
				case 0x0000f0:
					cz -= Math.cos(-a)*SPEED;
					cx -= Math.sin(-a)*SPEED;
					break;
			}
			switch(key&0x00ff00) {
				case 0x000f00:
					a += ROTATION;
					break;
				case 0x00f000:
					a -= ROTATION;
					break;
			}
			
			graphics.clear();
			var nx:Number;
			var nz:Number;
			var rx:Number;
			var rz:Number;
			var bx2:Array = new Array(bx.length);
			var by2:Array = new Array(by.length);
			var i:Number = 0;
			while(i<bz.length) {
				nx = cx-bx[i];
				nz = cz-bz[i];
				rx = cx+( nx*Math.cos(-a) )-( nz*Math.sin(-a) );
				rz = cz+( nx*Math.sin(-a) )+( nz*Math.cos(-a) );
				bx2[i] = vw+( ((cx-rx) / (cz-rz) )*vw);
				by2[i] = vh+( ((cy-by[i]) / (cz-rz) )*vh);
				++i;
			}
			
			graphics.lineStyle(1, 0xffffff, 100);
			
			graphics.moveTo(bx2[0], by2[0]);
			graphics.lineTo(bx2[1], by2[1]);
			graphics.lineTo(bx2[2], by2[2]);
			graphics.lineTo(bx2[3], by2[3]);
			graphics.lineTo(bx2[0], by2[0]);
			
			graphics.moveTo(bx2[4], by2[4]);
			graphics.lineTo(bx2[5], by2[5]);
			graphics.lineTo(bx2[6], by2[6]);
			graphics.lineTo(bx2[7], by2[7]);
			graphics.lineTo(bx2[4], by2[4]);
			
			graphics.moveTo(bx2[0], by2[0]);
			graphics.lineTo(bx2[4], by2[4]);
			graphics.moveTo(bx2[1], by2[1]);
			graphics.lineTo(bx2[5], by2[5]);
			graphics.moveTo(bx2[2], by2[2]);
			graphics.lineTo(bx2[6], by2[6]);
			graphics.moveTo(bx2[3], by2[3]);
			graphics.lineTo(bx2[7], by2[7]);
		}
		
		private function eventKeyDown(e:KeyboardEvent):void {
			switch(e.keyCode) {
				case Keyboard.UP:
					key = key | 0x00000f;
					break;
				case Keyboard.DOWN:
					key = key | 0x0000f0;
					break;
				case Keyboard.LEFT:
					key = key | 0x000f00;
					break;
				case Keyboard.RIGHT:
					key = key | 0x00f000;
					break;
			}
		}
		private function eventKeyUp(e:KeyboardEvent):void {
			switch(e.keyCode) {
				case Keyboard.UP:
					key = key ^ 0x00000f;
					break;
				case Keyboard.DOWN:
					key = key ^ 0x0000f0;
					break;
				case Keyboard.LEFT:
					key = key ^ 0x000f00;
					break;
				case Keyboard.RIGHT:
					key = key ^ 0x00f000;
					break;
			}
		}
	}
}